<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container mt-4">
        <h2>Lucky Dice Username</h2>
        <div class="form-group">
            <label for="username">User name:</label>
            <input type="email" class="form-control" id="input-username" placeholder="Enter username" name="username">
        </div>
        <div class="form-group">
            <button onclick="onBtnShowVoucherHistoryClick()" type="button" class="btn btn-primary">Show Voucher History
                Table</button>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
            <table id="table-voucher-history" class="table table-striped table-bordered table-hover">
                <thead>
                    <tr>
                        <th>Mã Giảm Giá</th>
                        <th>Phần Trăm Giảm</th>
                    </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>
    <!-- js -->
    <script>
        'use strict';
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gEND_OF_ROW_COL = -1;
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm xử lý sự kiện click
        function onBtnShowVoucherHistoryClick() {
            // Khai báo đối tượng để chứa dữ liệu
            var vPersonObj = {
                username: ""
            };
            // Bước 1: Thu thập dữ liệu
            thuThapDuLieu(vPersonObj);
            // Bước 2: Validate
            var vDuLieuHopLe = kiemTraDuLieu(vPersonObj);
            if (vDuLieuHopLe) {
                // Bước 3: Gọi API
                var vXmlHttpVoucherHistory = new XMLHttpRequest();
                goiApiLayLichSuVoucher(vPersonObj, vXmlHttpVoucherHistory);
                // Bước 4: Hiển thị
                vXmlHttpVoucherHistory.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        hienThiLichSuVoucher(vXmlHttpVoucherHistory);
                    }
                }

            }
        }
        /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Thu thập dữ liệu
        function thuThapDuLieu(paramPersonObj) {
            var vUserNameInput = document.getElementById("input-username");
            paramPersonObj.username = vUserNameInput.value.trim();
        }

        // Kiểm tra dữ liệu
        function kiemTraDuLieu(paramPersonObj) {
            if (paramPersonObj.username === "") {
                alert("Bạn cần nhập vào username!");
                return false;
            }
            return true;
        }

        // Gọi API
        function goiApiLayLichSuVoucher(paramPersonObj, paramXmlHttp) {
            paramXmlHttp.open("GET", gBASE_URL + "/voucher-history?username=" + paramPersonObj.username, true);
            paramXmlHttp.send();
        }

        function hienThiLichSuVoucher(paramXmlHttp) {
            console.log(paramXmlHttp.responseText);
            var vVoucherHistoryObj = JSON.parse(paramXmlHttp.responseText);
            // Truy xuất bảng
            var vVoucherHistoryTable = document.getElementById("table-voucher-history");
            for (var bI = 0; bI < vVoucherHistoryObj.vouchers.length; bI++) {
                // Thêm 1 dòng mới
                var bNewRow = vVoucherHistoryTable.insertRow(gEND_OF_ROW_COL);
                // Thêm 2 ô trong dòng
                var bVoucherCodeCell = bNewRow.insertCell(0);
                var bDiscountCell = bNewRow.insertCell(1);
                // Điền dữ liệu cho từng ô
                bVoucherCodeCell.innerHTML = vVoucherHistoryObj.vouchers[bI].maVoucher;
                bDiscountCell.innerHTML = vVoucherHistoryObj.vouchers[bI].phanTramGiamGia +"%";
            }
        }
    </script>

</html>